/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

 #ifndef __CBRAID_H__
 #define __CBRAID_H__
 
 typedef unsigned char uByte;
 typedef unsigned long uInt32;
 
 class CBraid
 {
 public:
 	CBraid();
	CBraid( uInt32 bnSize );
	virtual ~CBraid();
 
	uInt32 GetBnSize();
	void SetBnSize( uInt32 bnSize );
	
	void RandomLeftBraid( uInt32 braidResult[] );
	void RandomRightBraid( uInt32 braidResult[] );
	void RandomBraid( uInt32 braidResult[] );

	void BraidToPassword( uInt32 braid[], uByte password[] );

	void Reverse( uInt32 braid[], uInt32 braidResult[] );
	void Product( uInt32 braid1[], uInt32 braid2[], uInt32 braidResult[] );

private:
	uInt32 Random();
private:
	uInt32 bnSize;
	uInt32 seed;
};
 
 #endif // __CBRAID_H__
