/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CKNOTTTYPARAM_H__
#define __CKNOTTTYPARAM_H__


class CKnotttyParam
{
public:
	enum SESSIONMOD
	{
		UNKNOW = 0x00,
		SHELL = 0x01,
		XSHELL = 0x02,
		FTPUPLOAD = 0x03,
		FTPDOWNLOAD = 0x04
	};

public:
	CKnotttyParam();
	~CKnotttyParam();

	SESSIONMOD Init(int argc, char* argv[]);

	char* GetUserName(){return userName;};
	char* GetHostName(){return hostName;};
	char* GetPassword();
	char* GetSrcFilePathName(){return srcFilePathName;};
	char* GetDestFilePathName(){return destFilePathName;};
	int GetPort(){return port;};

	static void PrintHelp();

private:
	static int SearchUserName(char param[], char userName[]);
	static int SearchHostName(char param[], char hostName[]);
	static int SearchPathName(char param[], char pathName[]);
	static int SearchPort(char param[], int* pPort);

	static int SearchCharPos(char param[], char car);

	void Destroy();

private:
	char userName[100 + 1];
	char hostName[200 + 1];
	char password[100 + 1];
	char srcFilePathName[200 + 1];
	char destFilePathName[200 + 1];
	int port;
};

#endif // __CKNOTTTYPARAM_H__
