/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#include "CProgression.h"

#include <string.h>
#include <stdio.h>

CProgression::CProgression()
{
	message = NULL;
	range = 0;
	step = 0;
	current = 0;
}

CProgression::CProgression(float range, float step, char message[])
{
	this->message = NULL;
	this->range = 0;
	this->step = 0;
	this->current = 0;

	Init(range, step, message);
}

CProgression::~CProgression()
{
	Destroy();
}

void CProgression::Init(float range, float step, char message[])
{
	Destroy();

	this->message = new char[strlen(message) + 1];
	strcpy(this->message, message);

	this->range = range;
	this->step = step;
}

void CProgression::StepIt()
{
	current += step;
	Draw();
}

void CProgression::Draw()
{
	float ratio = current / range;
	float newRange = ratio * 25.;

	printf("\r[");
	for(float i = 0 ; i < newRange ; i++)
	printf("*");

	for(float i = newRange ; i < 25. ; i++)
	printf(" ");

	printf("] %.2f %% %s", ratio * 100., message);

	fflush(stdout);
}

void CProgression::Destroy()
{
	if(message)
	delete[] message;

	message = NULL;
	range = 0;
	step = 0;
	current = 0;
}
