/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CPROGRESSION_H__
#define __CPROGRESSION_H__

typedef unsigned long uInt32;

class CProgression
{
public:
	CProgression();
	CProgression(float range, float step, char message[]);

	~CProgression();

	void Init(float range, float step, char message[]);
	void StepIt();
	void Draw();

private:
	void Destroy();

private:
	char* message;
	float range;
	float step;
	float current;
};

#endif // __CPROGRESSION_H__
