/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CXCONNECTION_H__
#define __CXCONNECTION_H__

typedef unsigned char uByte;
typedef unsigned long uInt32;

#include <pthread.h> // for mutex

class CXConnection
{
public:
	enum {MAXSOCKETDATASIZE = 0xFFF0};

public:
	CXConnection();
	~CXConnection();

	int ConnectToServer(char adressServer[], int portServer);
	
	int XConnection();
	void Close();

	int Send(uByte data[], uInt32 dataSize);
	int Receive(uByte data[], uInt32 maxDataSize, uInt32* pDataSize);

private:
	void LockToSend();
	void UnLockToSend();
	
	void LockToReceive();
	void UnLockToReceive();


private:
	int socketServer;

	pthread_mutex_t mutexToSend;
	pthread_mutex_t mutexToReceive;
};
#endif // __CXCONNECTION_H__

