#!/bin/bash
#
# Init file for knotTTY server daemon
#
# chkconfig: 2345 55 25
# description: knotTTY server daemon
# processname: knotttyd
# config: /etc/knotttyd/knotttyd.conf
# pidfile: /var/run/knotttyd.pid

# source function library

. /etc/rc.d/init.d/functions

RETVAL=0
prog="knotttyd"


KNOTTTYD=/usr/sbin/knotttyd
CONFIG=/etc/knotttyd/knotttyd.conf
PID_FILE=/var/run/knotttyd.pid
PORT=1789

function start()
{
	gprintf "Starting %s:" "$prog"
	initlog -c "$KNOTTTYD $PORT" && success "stop" || failure "stop"
	RETVAL=$?
	[ "$RETVAL" = 0 ]
	echo
}

function stop()
{
	gprintf "Stopping %s:" "$prog"
	if [ -r /var/run/knotttyd.pid ]; then
	    kill -TERM `cat /var/run/knotttyd.pid`
	    RETVAL=$?
	    [ "$RETVAL" = 0 ] && success "stop" || failure "stop"
	else
	    success "already stopped"
	    RETVAL=0
	fi
	[ "$RETVAL" = 0 ]
	echo
}

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	restart)
		stop
		start
		;;
	status)
		status $KNOTTTYD
		RETVAL=$?
		;;
	*)
		gprintf "Usage: %s {start|stop|restart|status}\n" "$0"
		RETVAL=1
esac
exit $RETVAL

