/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CAES_H__
#define __CAES_H__

#include "aes.h"

typedef unsigned char      uByte;
typedef unsigned short     uInt16;
typedef unsigned long      uInt32;


class CAes
{
	public:
	CAes();
	CAes(char password[]);
	CAes(uByte password[]);
	~CAes();

	void Init(char password[]);
	void Init(uByte password[]);

	void Encrypt(uByte bufferIn[],uByte bufferOut[],uInt32 bufferSize);
	void Decrypt(uByte bufferIn[],uByte bufferOut[],uInt32 bufferSize);

	private:
	void ComputeNextPadding(void);

	private:
	uByte padding[16];
	aes_context context;
};

#endif
