/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#include "CAuthentication.h"

#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <shadow.h>
#include <unistd.h>
#include <string.h>


CAuthentication::CAuthentication()
{
	isAuthenticated = 0;
	userId = 0;
	groupId = 0;
	homePath = NULL;
	this->userName = NULL;
	shellPath = NULL;
}

CAuthentication::CAuthentication(char userName[], char password[])
{
	isAuthenticated = 0;
	userId = 0;
	groupId = 0;
	homePath = NULL;
	this->userName = NULL;
	shellPath = NULL;

	SetAccount(userName, password);
}

CAuthentication::~CAuthentication()
{
	isAuthenticated = 0;
	userId = 0;
	groupId = 0;

	if(homePath)
	{
		delete[] homePath;
		homePath = NULL;
	}

	if(userName)
	{
		delete[] userName;
		userName = NULL;
	}

	if(shellPath)
	{
		delete[] shellPath;
		shellPath = NULL;
	}

}


int CAuthentication::SetAccount(char userName[], char password[])
{
	isAuthenticated = 0;

	passwd* pPassword = getpwnam(userName);

	if(pPassword == NULL)
	return 0;

	userId = pPassword->pw_uid;
	groupId = pPassword->pw_gid;

	if(pPassword->pw_dir)
	{
		homePath = new char[strlen(pPassword->pw_dir) + 1];
		strcpy(homePath, pPassword->pw_dir);
	}

	this->userName = new char[strlen(userName) + 1];
	strcpy(this->userName, userName);

	if(pPassword->pw_shell)
	{
		shellPath = new char[strlen(pPassword->pw_shell) + 1];
		strcpy(shellPath, pPassword->pw_shell);
	}

	spwd* pShadow = getspnam(userName);
	
	if(pShadow == NULL)
	return 0;

	if(strcmp(pShadow->sp_pwdp, crypt(password, pShadow->sp_pwdp)) != 0)
	return 0;

	isAuthenticated = 1;

	return 1;
}


int CAuthentication::ApplyProcessusId()
{
	if(!IsAuthenticated())
	return 0;

	chdir(GetHomePath());
	setenv("HOME", GetHomePath(), 1);

	
	return setgid(GetGroupId()) == 0 && setuid(GetUserId()) == 0;
}
