/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CAUTHENTICATION_H__
#define __CAUTHENTICATION_H__

class CAuthentication
{
	typedef unsigned long uInt32;
	typedef unsigned char uByte;

public:
	CAuthentication();
	CAuthentication(char userName[], char password[]);
	~CAuthentication();
	
	int SetAccount(char userName[], char password[]);
	int ApplyProcessusId();

	int IsAuthenticated(){return isAuthenticated;};
	int GetUserId(){return userId;};
	int GetGroupId(){return groupId;};
	char* GetHomePath(){return homePath;};
	char* GetUserName(){return userName;};
	char* GetShellPath(){return shellPath;};


private:
	int isAuthenticated;
	int userId;
	int groupId;
	char* homePath;
	char* userName;
	char* shellPath;
};


#endif //__CAUTHENTICATION_H__
