/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CBUFFER_H__
#define __CBUFFER_H__

typedef unsigned long uInt32;
typedef unsigned char uByte;

class CBuffer
{
public:
	CBuffer();
	CBuffer(uInt32 maxBufferSize);
	CBuffer(uByte buffer[], uInt32 maxBufferSize);
	
	~CBuffer();
	
	int SetBuffer(uInt32 maxBufferSize);
	int SetBuffer(uByte buffer[], uInt32 maxBufferSize);

	uByte* GetBuffer(){return buffer;};
	char* GetSignedBuffer();

	uByte GetBuffer(uInt32 index);
	char GetSignedBuffer(uInt32 index);

	uInt32 GetBufferSize();
	uInt32 GetMaxBufferSize(){return maxBufferSize;};
public:
	uInt32 bufferSize;



private:
	void Destroy();
	
private:
	uByte* buffer;
	uInt32 maxBufferSize;
};

#endif // __CBUFFER_H__
