/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CSESSION_H__
#define __CSESSION_H__

#include "CSecureServer.h"
#include "CAuthentication.h"

#include <pthread.h>

class CSession
{
public:
	enum STATUS
	{
		AUTHENTICATED = 0x00,
		NOAUTHENTICATED = 0x01
	};

	enum SESSIONMOD
	{
		SHELL = 0x00,
		XSHELL = 0x01,
		FTP = 0x02
	};

public:
	static int StartSession(CSecureServer::CSecureConnection* pSecureConnection);

private:
	CSession(CSecureServer::CSecureConnection* pSecureConnection);
	~CSession();

	void StopSession();

private:
	CSecureServer::CSecureConnection* pSecureConnection;
	CAuthentication Authentication;
};

#endif // __CSESSION_H__
