/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CSESSIONFTP_H__
#define __CSESSIONFTP_H__

#include "CSecureServer.h"
#include "CAuthentication.h"

#include <pthread.h>

class CSessionFTP
{
public:
	enum REQUEST
	{
		DOWNLOAD = 0x00,
		UPLOAD = 0x01,
		LS = 0x02,
		CD = 0x03,
		QUIT = 0X04
	};

public:
	CSessionFTP();
	~CSessionFTP();

	int Start(CSecureServer::CSecureConnection* pSecureConnection, CAuthentication* pAuthentication);

private:
	int OnUpload();
	int OnDownload();
	int OnLS();
	int OnCD();

private:
	int GetFileSize(char fileName[], uInt32* pFileSize);
	
private:
	CSecureServer::CSecureConnection* pSecureConnection;
	CAuthentication* pAuthentication;
};

#endif // __CSESSIONFTP_H__
