/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CSESSIONSHELL_H__
#define __CSESSIONSHELL_H__

#include "CSecureServer.h"
#include "CVirtualTerm.h"
#include "CAuthentication.h"

#include <pthread.h>

class CSessionShell
{

public:
	CSessionShell();
	~CSessionShell();

	int Start(CSecureServer::CSecureConnection* pSecureConnection, CAuthentication* pAuthentication);
	int Stop();

private:
	int StartThreadIOTerm();
	static void* ThreadITerm(void* pvSessionShell);
	static void* ThreadOTerm(void* pvSessionShell);

private:
	CSecureServer::CSecureConnection* pSecureConnection;
	CAuthentication* pAuthentication;

	CVirtualTerm VirtualTerm;

	pthread_t threadITerm;
	pthread_t threadOTerm;
	
	pthread_attr_t thread_attrITerm;
	pthread_attr_t thread_attrOTerm;
};

#endif // __CSESSIONSHELL_H__
