/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#ifndef __CVIRTUALTERM_H__
#define __CVIRTUALTERM_H__

#include "CAuthentication.h"

typedef unsigned long uInt32;
typedef unsigned char uByte;

class CVirtualTerm
{
public:
	CVirtualTerm();
	CVirtualTerm(CAuthentication* pAuthentication, int xServerPort);
	~CVirtualTerm();

	int Create(CAuthentication* pAuthentication, int xServerPort);
	void Destroy();

	int Write(uByte data[], uInt32 dataSize);
	int Read(uByte data[], uInt32 maxDataSize, uInt32* pDataSize);

private:
	char* slavePath;
	int fdMaster;
	int shellPid;
};

#endif
