/*
 *  KnotTTY is a remote secure shell using the new public key exchange protocol
 *  with the Braid Group Cryptosystems
 *
 *  Copyright (C) 2006 Adrien Pinet
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 */

#include "CSecureServer.h"
#include "CSession.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/types.h>

int main(int argc, char* argv[])
{
	if(getuid() != 0)
	{
		printf("Only root can do this\n");
		return 1;
	}

	int pid = fork();
	
	if(pid)
	{
		FILE* f = fopen("/var/run/knotttyd.pid", "w");

		if(f == NULL)
		return 1;

		fprintf(f, "%d", pid);

		fclose(f);
		return 0;
	}

	CSecureServer SecureServer;

	if(!SecureServer.CreateServer(atoi(argv[1]), 1))
	return 1;

	while(1)
	{
		CSecureServer::CSecureConnection* pSecureConnection = SecureServer.WaitConnection();
		CSession::StartSession(pSecureConnection);
	}

	return 1;
}

